#!/usr/bin/env bash

module load rstudio-server/<%= context.rstudio_version %>
module load r/<%= context.r_version %>

#
# Start RStudio Server
#

# PAM auth helper used by RStudio
export RSTUDIO_AUTH="${PWD}/bin/auth"

# Generate an `rsession` wrapper script
export RSESSION_WRAPPER_FILE="${PWD}/rsession.sh"
(
umask 077
sed 's/^ \{2\}//' > "${RSESSION_WRAPPER_FILE}" << EOL
  #!/usr/bin/env bash

  # Log all output from this script
  export RSESSION_LOG_FILE="${PWD}/rsession.log"

  exec &>>"\${RSESSION_LOG_FILE}"

  # Launch the original command
  echo "Launching rsession..."
  set -x
  exec rsession --r-libs-user "${R_LIBS_USER}" "\${@}"
EOL
)
chmod 700 "${RSESSION_WRAPPER_FILE}"

export RSERVER_CONFIG="${PWD}/rserve.conf"

# Set working directory to home directory
cd "${HOME}"

export TMPDIR="$(mktemp -d)"

mkdir -p "$TMPDIR/rstudio-server"
python -c 'from uuid import uuid4; print(uuid4())' > "$TMPDIR/rstudio-server/secure-cookie-key"
chmod 0600 "$TMPDIR/rstudio-server/secure-cookie-key"

export RSERVER_DATA_DIR="$TMPDIR/rstudio-server/"
export RSERVER_DB_CONFIG="$RSERVER_DATA_DIR/dbconf"
(
umask 077
cat > "${RSERVER_DB_CONFIG}" << EOL
provider=sqlite
directory=${RSERVER_DATA_DIR}
EOL
)

R_ENV_PATH=$(which R | awk -F "/bin" '{print $1}')
(
umask 007
cat > "${RSERVER_CONFIG}" << EOL
rsession-which-r=${R_ENV_PATH}/bin/R
rsession-ld-library-path=${R_ENV_PATH}/lib:${R_ENV_PATH}/lib/server:${R_ENV_PATH}/jre/lib:${R_ENV_PATH}/jre/lib/amd64
auth-minimum-user-id=0
EOL
)

set -x
# Launch the RStudio Server
echo "Starting up rserver..."

export SINGULARITYENV_PREPEND_PATH=${R_ENV_PATH}/bin

CMD="rserver \
  --www-port '${port}' \
  --auth-none 1 \
  --rsession-path '${RSESSION_WRAPPER_FILE}' \
  --secure-cookie-key-file '${TMPDIR}/rstudio-server/secure-cookie-key' \
  --server-data-dir '${RSERVER_DATA_DIR}' \
  --database-config-file '${RSERVER_DB_CONFIG}' \
  --config-file '${RSERVER_CONFIG}' \
  --server-user '${USER}'"

# --auth-none 0
# --auth-pam-helper-path '${RSTUDIO_AUTH}'
# --auth-encrypt-password 0

<% if context.force_newgrp == "true" %>
  sg <%= context.slurm_account %> -c "eval ${CMD}"
<% else %>
  eval ${CMD}
<% end %>

echo 'Singularity as exited...'
